unit Netsov2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Variables, StdCtrls, ExtCtrls, Buttons;

type
  TFmMain = class(TForm)
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N5: TMenuItem;
    N7: TMenuItem;
    N6: TMenuItem;
    Panel1: TPanel;
    ListBox3: TListBox;
    Label1: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    ListBox5: TListBox;
    Label3: TLabel;
    Panel4: TPanel;
    d1: TSpeedButton;
    facts: TListBox;
    Label2: TLabel;
    Panel5: TPanel;
    seti: TListBox;
    Label4: TLabel;
    Panel6: TPanel;
    Panel7: TPanel;
    SpeedButton1: TSpeedButton;
    Panel8: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    lbout: TListBox;
    lblish: TListBox;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Timer2: TTimer;
    lbneobh: TListBox;
    Label7: TLabel;
    SpeedButton6: TSpeedButton;
    N4: TMenuItem;
    N8: TMenuItem;
    procedure N3Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ListBox3Click(Sender: TObject);
    procedure ListBox3Exit(Sender: TObject);
    procedure ListBox5Click(Sender: TObject);
    procedure ListBox5Exit(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure factsClick(Sender: TObject);
    procedure factsExit(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure setiClick(Sender: TObject);
    procedure setiExit(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N4Click(Sender: TObject);



  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FmMain: TFmMain;

implementation

uses laba2, help2;

{$R *.DFM}

procedure TFmMain.N3Click(Sender: TObject);

var i,k,j:integer;
   FF: TFF;
   FactFile:TFactFile;
begin
      SaveDialog1.Filter:='Dat files|*.dat';
if SaveDialog1.Execute then
  begin
   assignfile(FF,SaveDialog1.filename+'.dat');
   rewrite(FF);
   for i:=1 to NFF do
     Begin
       FactFile.Number:=VectFact[i].Number;
       FactFile.Znach:=VectFact[i].Znach;
       FactFile.Q:=0;
        FactFile.Zel:=0;
       for j:=1 to NR do
         if VectFact[i].Number=BaseKnow.Rule[j].Number then
           begin
                FactFile.Q:= BaseKnow.Rule[j].Q;
                FactFile.Zel:= BaseKnow.Rule[j].Zel;
                for k:=1 to  BaseKnow.Rule[j].Q do
                   FactFile.FactIn[k]:=BaseKnow.Rule[j].FactIn[k];
           end;
       write(ff,FactFile);
     end;
  end
else exit;
closefile(FF);
end;


procedure TFmMain.N8Click(Sender: TObject);
begin
  form1.showmodal;
end;

procedure TFmMain.FormCreate(Sender: TObject);
var
   Know:TKnow;
   Fact:TFact;  FactFile:TFactFile;
   i,j:integer;
begin
     NF:=0;NF1:=0;NK:=0; NFF:=0; Num:=0;

 end;



procedure TFmMain.SpeedButton2Click(Sender: TObject);
var
  rab:integer;
begin
  rab:=ListBox3.itemindex;
  facts.Items.Add(VectFact[rab+1].Znach);
  NF1:=NF1+1;
  SpisF[NF1]:=VectFact[rab+1].Number;
  BaseKnow.Fact[NF1]:=VectFact[rab+1].Number;
  NF:=NF1;
  SpeedButton1.Enabled:=true;
end;

procedure TFmMain.SpeedButton4Click(Sender: TObject);
var rab,i,j:integer;
begin
  If NK=1 then
  begin
  showmessage('    !');
  exit;
  end
  else
  begin
  rab:=ListBox5.itemindex;
  for i:=1 to NFF do
    if BaseKnow.Rule[rab+1].Number=VectFact[i].Number then
    begin
      Seti.Items.Add(VectFact[i].Znach);
      NK:=NK+1;
      Knowledge[NK]:=VectFact[i].Number;
    end;
  end;
  SpeedButton1.Enabled:=true;
end;


procedure TFmMain.ListBox3Click(Sender: TObject);
begin
 SpeedButton2.Enabled:=true;
end;

procedure TFmMain.ListBox3Exit(Sender: TObject);
begin
 SpeedButton2.Enabled:=false;

end;

procedure TFmMain.ListBox5Click(Sender: TObject);
begin
 SpeedButton4.Enabled:=true;
end;

procedure TFmMain.ListBox5Exit(Sender: TObject);
begin
   SpeedButton4.Enabled:=false;
end;
procedure load;
var
  i:integer;
  FF: TFF;
  FactFile:TFactFile;
begin
i:=0;
 fmmain.OpenDialog1.Filter:=' |*.dat';
if not fmmain.OpenDialog1.Execute  then
  exit;
if FileExists(fmmain.OpenDialog1.FileName)=false then
  begin
    Application.MessageBox('     !','Error',MB_iconwarning);
    exit;
  end
else
  begin
   AssignFile(FF,fmmain.OpenDialog1.FileName);
   reset(FF);
   NR:=0;
   NFF:=0;
     While Not eof(FF) do
     begin
          Read(FF,FactFile);
          NFF:=NFF+1;
          VectFact[NFF].Number:=FactFile.Number;
          VectFact[NFF].Znach:=FactFile.Znach;
          fmmain.ListBox3.Items.Add(VectFact[NFF].Znach);
          if FactFile.Q>1 then
          begin
              NR:=NR+1;
              BaseKnow.Rule[NR].Number:=FactFile.Number;
              BaseKnow.Rule[NR].Zel:=FactFile.Zel;
              fmmain.ListBox5.Items.Add(FactFile.Znach);
              BaseKnow.Rule[NR].Q:=FactFile.Q;
              for i:=1 to BaseKnow.Rule[NR].Q do
               BaseKnow.Rule[NR].FactIn[i]:=FactFile.FactIn[i];
          end;
    end;
end;
closefile(FF);
end;

procedure TFmMain.N2Click(Sender: TObject);
var
  inf:integer;
begin
  inf:=Application.Messagebox('   .   ?','',MB_YESNO+MB_ICONwarning);
  if inf=idNO then
   exit;
  if inf=idYes then
   begin

     ListBox3.Clear;
     facts.Clear;
     ListBox5.Clear;
     seti.Clear;
     Load;
   end;
end;

procedure TFmMain.SpeedButton3Click(Sender: TObject);
var
   rab,i,j:integer;
begin
  if NF1>0 then
  begin
    rab:=facts.Itemindex;
    for i:=rab+1 to NF1-1 do
      begin
         SpisF[i]:=SpisF[i+1];
         BaseKnow.Fact[i]:=BaseKnow.Fact[i+1];
      end;
    NF1:=NF1-1; NF:=NF1;
    facts.Clear;
    for i:=1 to NF1 do
      for j:=1 to NFF do
        if SpisF[i]=VectFact[j].Number then
          facts.Items.Add(VectFact[j].Znach);
   end;
   SpeedButton3.Enabled:=false;
   If (facts.Items.Count=0) and (facts.Items.Count=0)then   SpeedButton1.Enabled:=false;
end;



procedure TFmMain.factsClick(Sender: TObject);
begin
 if facts.Items.Count>0 then SpeedButton3.Enabled:=true;
end;

procedure TFmMain.factsExit(Sender: TObject);
begin
  SpeedButton3.Enabled:=false;
end;

procedure TFmMain.SpeedButton5Click(Sender: TObject);
 var
   rab,i,j:integer;
begin
   if NK>0 then
   begin
        rab:=seti.Itemindex;
        for i:=rab+1 to NK-1 do
          Knowledge[i]:=Knowledge[i+1];
        NK:=NK-1;
         seti.Clear;
        for i:=1 to NK do
          for j:=1 to NFF do
            if Knowledge[i]=VectFact[j].Number then
                seti.Items.Add(VectFact[j].Znach);
   end;
  SpeedButton5.Enabled:=false;
  If (seti.Items.Count=0) and (facts.Items.Count=0)then   SpeedButton1.Enabled:=false;
end;



procedure TFmMain.setiClick(Sender: TObject);
begin
 if seti.Items.count>0 then SpeedButton5.Enabled:=true;
end;

procedure TFmMain.setiExit(Sender: TObject);
begin
  SpeedButton5.Enabled:=false;
end;

Procedure Direct;
var
    KIZ,NS,KA,k,i,l,j:integer;
begin
    {   }
    KEnd:=0;KIZ:=0;NS:=0;

     While ((KEnd=0) and (KIZ=0)) do
     begin
        {     ,   }
        {       }
        {  }
         KIZ:=1;
         i:=1;
         While (i<=NR) and (Kend=0) do
         begin
             {    }
             { }
             KA:=0; {:    ?}
             k:=1;
             While ((KA=0) and (K<=NF)) do
             begin
                 if BaseKnow.Rule[i].Number=BaseKnow.Fact[k] then
                   KA:=1; {    }
                 k:=k+1;
             end;
             {:    ?}
             j:=1;
             While ((j<=BaseKnow.Rule[i].Q) and (KA=0)) do
             begin
                  {  }
                  KA:=1; k:=1;
                  While (k<=NF) and (KA=1) do
                  begin
                       {   }
                       {    }
                       if BaseKnow.Rule[i].FactIn[j]=BaseKnow.Fact[k] then
                          KA:=0;
                       k:=k+1;
                  end;
                  {   =1,   ,}
                  {  }
                  j:=j+1;
             end;

             if KA=0 then
             begin
                  { ,   }
                  { ,   }
                  NF:=NF+1;
                  BaseKnow.Fact[NF]:=BaseKnow.Rule[i].Number;
                  KIZ:=0;
                       {:    }
                       {}
                       if BaseKnow.Rule[i].Zel=1 then
                         begin
                             KEND:=1;
                             Rez:=BaseKnow.Rule[i].Number;
                         end;

             end;
             i:=i+1;
         end;
         {    }
         {  }
     end;

end;

Procedure Inv;
var
    KVPC,KVPF,AnFact,NS1,Rab,FindFactAn:integer;
    L,NS,i,j,k,KA:integer;
begin
       {  }
     KEnd:=0; L:=1;   NST:=0;
     While (L<=NK) do
     begin
          {   }
          {,    }
          { -.  }
          KEND:=0;
          Nst:=Nst+1;
          Spis[Nst]:=Knowledge[l];
          While (Kend=0)do
          begin
               FindFactAn:=0;
               j:=0;
               While (FindFactAn=0)and( j<=NST) do  {   }
               begin
                 for  k:=1 to NR do
                    if BaseKnow.Rule[k].Number=Spis[j]
                      then
                       begin
                         FindFactAn:=1;         {,   }
                         AnFact:=Spis[j];       {  }
                         for i:=j to Nst-1 do
                           Spis[i]:=Spis[i+1];
                         Nst:=Nst-1;
                       end;
                 j:=j+1;
               end;
               if FindFactAn=0 then
                 KEnd:=1        {   ,  }
               else
               begin
                  i:=1;
                  While (I<=NR) do
                  begin
                      { -  }
                      { }
                      if AnFact=BaseKnow.Rule[i].Number then
                      begin
                         {   }
                          for j:=1 to BaseKnow.Rule[i].Q do
                          begin
                              NST:=NST+1;
                              Spis[Nst]:=BaseKnow.Rule[i].FactIn[j];
                          end;
                      end;{   }
                      i:=i+1;
                  end;{While }
               end;

          end;
         l:=l+1;
     end;{    }
     if NST=NK then KEND:=0 else KEND:=1;
     {        }
end;


procedure TFmMain.SpeedButton1Click(Sender: TObject);
var
   i,j,k,KA,l:integer;
   yes: boolean;
begin
  yes:=true;
  fmmain.lbout.Clear;
  fmmain.lblish.Clear;
  fmmain.lbneobh.Clear;
    if (NF1<>0) and (NK=0) then    { ,   }
      begin
         Direct;
         if Kend<>0 then
           begin
             for i:=1 to NFF do
               if VectFact[i].Number=Rez then
                 lbneobh.Items.Add(VectFact[i].Znach);
             Label7.Caption:='    ';
              end
           else
           begin
           ShowMessage('     ');
           yes:=false;
           end;
      end;
    if (NF1=0) and (NK<>0) then {  ,  }
    begin
        Inv;
        if KEnd<>0 then
          begin
            for i:=1 to NST do
              for j:=1 to NFF do
                if Spis[i]=VectFact[j].Number then
                   lbneobh.Items.Add(VectFact[j].Znach);
             Label7.Caption:=' ';
          end;
    end;
    if (NK<>0) and (NF1<>0) then {     }
    begin
      k:=1;
        While (k<=NR) do
          begin             {   }
               i:=1;     {     }
               KA:=0;
               While (i<=NF1)and (KA=0) do
               begin
                   if BaseKnow.Rule[k].Number=SpisF[i] then
                      begin
                          for j:=i to NF1-1 do
                            SpisF[j]:=SpisF[j+1];
                          NF1:=NF1-1;
                          KA:=1;
                      end;
                   i:=i+1;
               end;
               if KA=1 then
               begin
                   for i:=1 to BaseKnow.Rule[k].Q do
                    begin
                         NF1:=NF1+1;
                         SpisF[NF1]:=BaseKnow.Rule[k].FactIn[i];
                    end;
                    k:=0;
                end;
                k:=k+1;
          end;

          INV;

          i:=1;
          While i<=NF1 do   {,  }
          begin             {   }
               KA:=0;
               j:=1;
               While (j<=NST) and (KA=0) do
               begin
                    if SpisF[i]=Spis[j] then
                       Ka:=1;
                    j:=j+1;
               end;
               if KA=1 then
               begin
                    for k:=i to NF1-1 do
                      SpisF[k]:=SpisF[k+1];
                    i:=i-1;
                    NF1:=NF1-1;
                    for l:=j-1 to NST-1 do
                      Spis[l]:=Spis[l+1];
                    NST:=Nst-1;
               end;
               i:=i+1;
          end;
        if (Nst=0)and (NF1=0) then
           Timer2.Enabled:=true else
           begin
                KA:=0;
                for i:=1 to NST do
                  for j:=1 to NFF do
                  begin
                    if (Spis[i]=VectFact[j].Number) and (KA=0)  then
                      begin

                        KA:=1;
                      end;
                    if (Spis[i]=VectFact[j].Number) and (KA=1)  then
                       Lbout.Items.Add(VectFact[j].Znach);
                  end;
                KA:=0;
                for i:=1 to NF1 do
                  for j:=1 to NFF do
                  begin
                    if (SpisF[i]=VectFact[j].Number) and (KA=0) then
                      begin

                         KA:=1;
                      end;
                    if (SpisF[i]=VectFact[j].Number) and (KA=1) then
                      lblish.Items.Add(VectFact[j].Znach);
                  end;
           end;
    end;
    if (Nk=0) and (NF1=0) then
     begin
       ShowMessage('  ');

     end;

  facts.Clear;
  seti.clear;
  NF:=0;NF1:=0;NK:=0;  Num:=0;
  speedbutton1.Enabled:=false;
  If (lblish.Items.Count=0)and(lbout.Items.Count=0)and(lbneobh.Items.Count=0)and(yes) then showmessage(' ');
end;


procedure TFmMain.SpeedButton6Click(Sender: TObject);
begin
  fmmain.lbout.Clear;
  fmmain.lblish.Clear;
  fmmain.lbneobh.Clear;
end;

procedure TFmMain.N5Click(Sender: TObject);
begin
  fmmain.close;
end;

procedure TFmMain.N6Click(Sender: TObject);
begin
  form2.showmodal;
end;


procedure TFmMain.N4Click(Sender: TObject);
begin
  winexec('netpr.exe',SW_SHOW);
end;

end.







