unit laba2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Variables;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    SpeedButton11: TSpeedButton;
    ListBox2: TListBox;
    SpeedButton9: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ListBox4: TListBox;
    Label4: TLabel;
    Label5: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    RadioGroup1: TListBox;
    Label7: TLabel;
    SpeedButton5: TSpeedButton;
    Shape3: TShape;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Shape4: TShape;


    procedure AddSimpleFact;
    procedure AddComplexFact;
    procedure SpeedButton11Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure DeleteFact;
    procedure Edit1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure ListBox2Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Netsov2;

{$R *.DFM}


procedure TForm1.AddSimpleFact;
  var
    i,t:integer;
    r:string;
  begin
  r:=edit1.text;
  for i:=1 to NFF do
    if r=VectFact[i].Znach then
      begin
        ShowMessage('    !');
        exit;
      end;
  t:=VectFact[NFF].Number;
  NFF:=NFF+1;
  VectFact[NFF].Number:=t+1;
  VectFact[NFF].Znach:=r;
  ListBox1.items.add(VectFact[NFF].Znach);
  fmmain.ListBox3.items.add(VectFact[NFF].Znach);
end;

procedure TForm1.AddComplexFact;
var
  i,t:integer;
  r:string;
begin
r:=edit1.text;
for i:=1 to NFF do
  if r=VectFact[i].Znach then
    begin
      ShowMessage('    !');
      exit;
    end;
t:=VectFact[NFF].Number;
NFF:=NFF+1;
VectFact[NFF].Number:=t+1;
VectFact[NFF].Znach:=r;
ListBox1.items.add(VectFact[NFF].Znach);
fmmain.ListBox3.items.add(VectFact[NFF].Znach);
fmmain.ListBox5.items.add(VectFact[NFF].Znach);
NR:=NR+1;
BaseKnow.Rule[NR].Number:=VectFact[NFF].Number;
BaseKnow.Rule[NR].Q:=Num;
BaseKnow.Rule[NR].Zel:=1;
for i:=1 to Num do
BaseKnow.Rule[NR].FactIn[i]:=SpisF[i];

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
if radiogroup1.ItemIndex=0 then
 begin
  ListBox4.Enabled:=false;
  label5.Enabled:=false;
  speedbutton11.enabled:=false;
  edit1.SetFocus;
 end;
if radiogroup1.ItemIndex=1 then
 begin
  ListBox4.Enabled:=true;
  label5.Enabled:=true;
  speedbutton11.enabled:=true;
  edit1.SetFocus;
 end;
 if (RadioGroup1.ItemIndex=0)and(edit1.Text<>'')then
 speedbutton9.Enabled:=true;
 if (RadioGroup1.ItemIndex=1)and(edit1.Text<>'')and(ListBox4.Items.Count<> 0)and(Num=0)then
 speedbutton9.Enabled:=true;
end;




procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
if radiogroup1.ItemIndex=0 then
  if edit1.Text='' then
    begin
      ShowMessage(' !');
      exit;
    end
  else
  AddSimpleFact;


  if radiogroup1.ItemIndex=1 then
  if (edit1.Text='') or (ListBox4.Items.Count = 0)or (Num=0)then
    begin
      ShowMessage('  !');
      exit;
    end
  else
   begin
    AddComplexFact;
    ListBox4.Clear;
   end;

edit1.Clear;
Num:=0;
SpeedButton9.Enabled:=false;
form1.listbox1.SetFocus ;
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
var rab:integer;
begin
  rab:=ListBox1.itemindex;
  ListBox4.Items.Add(VectFact[rab+1].Znach);
  ListBox4.ItemIndex:=0;
  Num:=Num+1;
  SpisF[Num]:=VectFact[rab+1].Number;
  SpeedButton11.Enabled:=false;
 if (RadioGroup1.ItemIndex=0)and(edit1.Text<>'')then
 speedbutton9.Enabled:=true;
 if (RadioGroup1.ItemIndex=1)and(edit1.Text<>'')and(ListBox4.Items.Count > 0)then
 speedbutton9.Enabled:=true;

end;

procedure TForm1.DeleteFact;
var
  i,j,rab,t,k:integer;
begin
  rab:=ListBox1.ItemIndex+1;
  k:=VectFact[rab].Number;

  for i:=1 to NR do
    for j:=1 to BaseKnow.Rule[i].Q do
      if BaseKnow.Rule[i].FactIn[j]=k then
      begin
        ShowMessage('   !');
        exit;
      end;

  for i:=rab to NFF-1 do
    begin
      VectFact[i].Number:=VectFact[i+1].Number;
      VectFact[i].Znach:=VectFact[i+1].Znach;
    end;
  NFF:=NFF-1;
  for i:=1 to NR do
    if k=BaseKnow.Rule[i].Number then
      begin
        for t:=i to NR-1 do
          begin
             BaseKnow.Rule[t].Number:=BaseKnow.Rule[t+1].Number;
             BaseKnow.Rule[t].Q:=BaseKnow.Rule[t+1].Q;
             BaseKnow.Rule[t].Zel:=BaseKnow.Rule[t+1].Zel;
             for j:=1 to BaseKnow.Rule[t].Q do
               BaseKnow.Rule[t].FactIn[j]:=BaseKnow.Rule[t+1].FactIn[j];
          end;
      NR:=NR-1;
      end;

ListBox1.Clear;
ListBox2.Clear;
fmmain.ListBox3.Clear;
fmmain.ListBox5.Clear;
for i:=1 to NFF do
  begin
    ListBox1.Items.Add(VectFact[i].Znach);
    fmmain.ListBox3.Items.Add(VectFact[i].Znach);
    for j:=1 to NR do
      if VectFact[i].Number=BaseKnow.Rule[j].Number then
        fmmain.ListBox5.Items.Add(VectFact[i].Znach);
  end;

end;




procedure TForm1.ListBox1Click(Sender: TObject);
var
  i,j,rab,r,t:integer;
begin
speedbutton2.Enabled:=false;
t:=0;
ListBox2.Clear;
rab:=ListBox1.Itemindex;
for i:=1 to NR do
  if VectFact[rab+1].Number=BaseKnow.Rule[i].Number then
    begin
      t:=1;
      for j:=1 to BaseKnow.Rule[i].Q do
        for r:=1 to NFF do
          if VectFact[r].Number=BaseKnow.Rule[i].FactIn[j]then
            ListBox2.Items.Add(VectFact[r].Znach);
    end;

  If RadioGroup1.ItemIndex=1 then SpeedButton11.Enabled:=true;
  SpeedButton5.Enabled:=true;
   {}

end;


procedure TForm1.FormActivate(Sender: TObject);
var

   i,j:integer;
begin
     SpeedButton11.Enabled:=false;
     ListBox4.Enabled:=false;
     label5.Enabled:=false;
     RadioGroup1.ItemIndex:=0;

     for i:=1 to Nff do
     begin
        ListBox1.Items.Add(VectFact[i].Znach);
    end;

end;
procedure TForm1.SpeedButton5Click(Sender: TObject);
var
  inf:integer;
begin
  inf:=Application.Messagebox('    ?','',MB_YESNO+MB_ICONQUESTION);
  if inf=idNO then
   exit;
  if inf=idYes then
    DeleteFact;
  SpeedButton5.Enabled:=false;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 if (RadioGroup1.ItemIndex=0)and(edit1.Text<>'')then
 speedbutton9.Enabled:=true;
 if (RadioGroup1.ItemIndex=1)and(edit1.Text<>'')and(ListBox4.Items.Count<> 0)and(Num=0)then
 speedbutton9.Enabled:=true;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 form1.Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
       listbox1.Clear;
       listbox2.Clear;
       listbox4.clear;
end;





procedure TForm1.ListBox2Click(Sender: TObject);
begin
    speedbutton2.Enabled:=true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);

  var
  inf:integer;
  i,j,t,rab,k,r:integer;
begin


  inf:=Application.Messagebox('    ?','',MB_YESNO+MB_ICONQUESTION);
  if inf=idNO then
   exit;
  if inf=idYes then
  begin

  rab:=ListBox1.ItemIndex+1;
  k:=VectFact[rab].Number;

  for j:=1 to NR do
  if   BaseKnow.Rule[j].Number = k then
  begin
     for I:=listbox2.ItemIndex+1  to BaseKnow.Rule[j].Q do
     BaseKnow.Rule[j].FactIn[i]:= BaseKnow.Rule[j].FactIn[i+1];
     BaseKnow.Rule[j].Q:=BaseKnow.Rule[j].Q-1;
  end;
end;
   Form1.ListBox1Click(Sender);
end;

end.


